From 59d6b55537b7502303ec0f408fb179ba57c13845 Mon Sep 17 00:00:00 2001
From: Tim Bielawa <Tim 'Shaggy' Bielawa>
Date: Thu, 22 Oct 2009 10:49:48 -0400
Subject: [PATCH] Added method for enabling autostart on qemu domains

---
 koan/app.py   |    3 ++-
 koan/utils.py |   14 ++++++++++++++
 2 files changed, 16 insertions(+), 1 deletions(-)

diff --git a/koan/app.py b/koan/app.py
index 752ec0a..6a3fae8 100755
--- a/koan/app.py
+++ b/koan/app.py
@@ -1160,9 +1160,10 @@ class Koan:
         if virt_auto_boot:
             if self.virt_type in [ "xenpv", "xenfv" ]:
                 utils.create_xendomains_symlink(virtname)
+            elif self.virt_type == "qemu":
+               utils.libvirt_enable_autostart(virtname)
             else:
                 print "- warning: don't know how to autoboot this virt type yet"
-            # else qemu
             # else...
         return results
 
diff --git a/koan/utils.py b/koan/utils.py
index 4fb4d26..dc31abe 100644
--- a/koan/utils.py
+++ b/koan/utils.py
@@ -424,6 +424,20 @@ def create_xendomains_symlink(name):
     else:
         raise InfoException("Could not create /etc/xen/auto/%s symlink.  Please check write permissions and ownership" % name)
 
+def libvirt_enable_autostart(domain_name):
+   import libvirt
+   try:
+      conn = libvirt.open("qemu:///system")
+      print "- pausing for a few seconds to allow libvirt to register the new domain"
+      time.sleep(5)
+      domain = conn.lookupByName(domain_name)
+      domain.setAutostart(1)
+   except:
+      raise InfoException("libvirt could not find domain %s" % domain_name)
+
+   if not domain.autostart:
+      raise InfoException("Could not enable autostart on domain %s." % domain_name)
+
 def make_floppy(kickstart):
 
     (fd, floppy_path) = tempfile.mkstemp(suffix='.floppy', prefix='tmp', dir="/tmp")
-- 
1.6.2.5

